#include "obj17_db_api.h"
#include "obj17_db_dbd.h"

using namespace RDM_CPP;

Db_obj17_db Db_obj17_db::Open (char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), "obj17_db", mode, &obj17_db_dbd, sizeof(obj17_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj17_db Db_obj17_db::Open (wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), L"obj17_db", mode, &obj17_db_dbd, sizeof(obj17_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

Db_obj17_db Db_obj17_db::Open (const char *name, const char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj17_db_dbd, sizeof(obj17_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj17_db Db_obj17_db::Open (const wchar_t *name, const wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj17_db_dbd, sizeof(obj17_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

dbType Db_obj17_db::Type (void) {
    char static type;
    return &type;
}

Db_obj17_db::Db_obj17_db (void) throw () {
}

Db_obj17_db::Db_obj17_db (const Db& db) throw () : Db (db, Type()) {
}

Db_obj17_db::Db_obj17_db (const Db_obj17_db& db) throw () : Db (db) {
}

Db_obj17_db::Db_obj17_db (IDb *idb) : Db (idb) {
}

Db_obj17_db& Db_obj17_db::operator = (const Db& db) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), db);
    return *this;
}

Db_obj17_db& Db_obj17_db::operator = (const Db_obj17_db& db) throw () {
    *((Db *)this) = db;
    return *this;
}

Db_obj17_db::~Db_obj17_db () {
}

Cursor_rec01 Db_obj17_db::New_rec01_record (void) const throw (rdm_exception&) {
    return Cursor_rec01 (NewRecords (Cursor_rec01::Type ()));
}

Cursor_rec01 Db_obj17_db::New_rec01_recordWithFieldValues (struct rec01 *fields) const throw (rdm_exception&) {
    return Cursor_rec01 (NewRecordsWithFieldValues (Cursor_rec01::Type (), fields));
}

Cursor_rec01 Db_obj17_db::Get_rec01_records (void) const throw (rdm_exception&) {
    return Cursor_rec01 (GetRecords (Cursor_rec01::Type ()));
}

Cursor_rec01 Db_obj17_db::Get_rec01_recordsBy_field01 () const throw (rdm_exception&) {
    return Cursor_rec01 (GetRecordsByKey (FIELD01));
}

recordType Cursor_rec01::Type (void) {
    return REC01;
}

Cursor_rec01::Cursor_rec01 (void) throw () {
}

Cursor_rec01::Cursor_rec01 (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_rec01::Cursor_rec01 (const Cursor_rec01& cursor) throw () : Cursor (cursor) {
}

Cursor_rec01& Cursor_rec01::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_rec01& Cursor_rec01::operator = (const Cursor_rec01& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_rec01 Cursor_rec01::GetRecordsBy_field01 () const throw (rdm_exception&) {
    return Cursor_rec01 (GetRecordsByKey (FIELD01));
}

void Cursor_rec01::KeyFindBy_field01 (int32_t *field01_val) const throw (rdm_exception&) {
    FindRecordsByKey(FIELD01, 0, 0, field01_val);
}

void Cursor_rec01::SetFieldValues (const struct rec01 *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_rec01::GetFieldValues (struct rec01 *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_rec01::Set_field01 (int32_t field01_val) const throw (rdm_exception&) {
    SetField (FIELD01, &field01_val);
}

void Cursor_rec01::Get_field01 (int32_t *field01_val) const throw (rdm_exception&) {
    GetField (FIELD01, field01_val);
}

Cursor_rec01::~Cursor_rec01 () {
}

